<?php

/*********************************************************************

 サークルカップリングクラウド表示プラグイン (2013/04/15)

 freo.jp
 customize by 32877(http://32877.xii.jp)

*********************************************************************/

/* メイン処理 */
function freo_display_circle_couplingcloud()
{
	global $freo;

	//サークルカップリング情報取得
	$couplings = array();
	if ($fp = fopen(FREO_FILE_DIR . 'plugins/circle_couplingcloud.log', 'r')) {
		while ($line = fgets($fp)) {
			list($coupling, $count) = explode(',', trim($line));

			$couplings[$coupling] = $count;
		}
	} else {
		freo_error('サークルカップリング情報保存ファイル ' . FREO_FILE_DIR . 'plugins/circle_couplingcloud.log を読み込めません。');
	}

	//最大値と最小値を取得
	$max_count = empty($couplings) ? 0 : max(array_values($couplings));
	$min_count = empty($couplings) ? 0 : min(array_values($couplings));

	//値の範囲を取得
	$spread = $max_count - $min_count;
	if ($spread == 0) {
	    $spread = 1;
	}

	//サイズの比率を取得
	$step = ($freo->config['plugin']['circle_couplingcloud']['max_size'] - $freo->config['plugin']['circle_couplingcloud']['min_size']) / $spread;

	//カップリングクラウド取得
	$couplingclouds = array();

	foreach ($couplings as $coupling => $count) {
		$couplingclouds[] = array(
			'coupling'   => $coupling,
			'count' => $count,
			'size'  => intval($freo->config['plugin']['circle_couplingcloud']['min_size'] + (($count - $min_count) * $step))
		);
	}

	//データ割当
	$freo->smarty->assign(array(
		'plugin_circle_couplingclouds' => $couplingclouds
	));

	return;
}

?>
